#
# general checks
# $Id: checkall.pl,v 1.2 2001/04/30 20:42:07 mharo Exp $
#

use strict;
use vars qw/%makevar %mastersites %opts $nfatal $nwarn $ninfo $prog/;
use Data::Dumper;

########################################  FUNCTIONS BELOW THIS POINT

sub whitespaceatend {
	my ($file, $whole) = @_;
	
	my $problem = 0;
	my $i = 1;
	foreach my $line (split(/\n/, $whole)) {
		if ($line =~ /[ \t]$/) {
			&perror("WARN: $file $i: whitespace before end of line");
			$problem = 1;
		}
		$i++;
	}

	if (! $problem) {
		&verbose("$file has no whitespace before the end of a line");
	}
}

sub lastline {
	my ($file, $whole) = @_;

	my $problems = 0;
	
	if ($whole !~ /\n$/) {
		&perror("FATAL: $file: last line needs to be terminated by a \\n");
		$problems=1;
	}
	if ($whole =~ /\n([ \t]*\n)+$/) {
		&perror("WARN: $file: last line seems to be blank.");
		$problems=1;
	}
	if (! $problems) {
		&verbose("last line of $file looks good to me");
	}
}

########################################  FUNCTION REGISTRATION

my @func_reg = (
{
  function => \&whitespaceatend,
  name => "whitespaceatend",
  option => undef,
  enabled => 1,
  file => undef
},
{
  function => \&lastline,
  name => "lastline",
  option => undef,
  enabled => 1,
  file => undef
},
);

#print Data::Dumper->Dump([\@func_reg],['@func_reg']);
\@func_reg;
