#
# other checks
# $Id: checkpkg.pl,v 1.2 2001/04/30 20:42:07 mharo Exp $
#

use strict;
use vars qw/%makevar %mastersites %opts $nfatal $nwarn $ninfo $prog/;
use Data::Dumper;

########################################  FUNCTIONS BELOW THIS POINT

sub descrwwwcheck {
	my ($file, $whole) = @_;

	if ($whole =~ m,http://,) {
		my $has_url = 0;
		my $has_www = 0;
		foreach my $line (grep($_ =~ "http://", split(/\n+/, $whole))) {
			$has_url = 1;
			$line =~ m,(http://[\w\-\.]+),;
			my $url = $1;
			&geturlstatus($url);
			if ($line =~ m,WWW:[ \t]+http://,) {
				$has_www = 1;
			}
		}

		if ($has_url && ! $has_www) {
			&perror("FATAL: $file: contains a URL but no WWW:");
		} else {
			&verbose("$file a URL is prefixed with WWW:");
		}
	}
}

sub commentstylecheck {
	my ($file, $whole) = @_;
	
	if ($whole !~ /^["0-9A-Z]/) {
		&perror("WARN: $file: Line should begin with a capital letter")
	}
	if ($whole =~ /\.$/) {
		&perror("WARN: $file: Line should end without a period.");
	}
}

########################################  FUNCTION REGISTRATION

my @func_reg = (
{
  function => \&descrwwwcheck,
  name => "descrwwwcheck",
  option => "descrwwwcheck",
  enabled => 1,
  file => "pkg-descr"
},
{
  function => \&commentstylecheck,
  name => "commentstylecheck",
  option => "commentstylecheck",
  enabled => 1,
  file => "pkg-comment"
},
);

#print Data::Dumper->Dump([\@func_reg],['@func_reg']);
\@func_reg;
